#
# Copyright (c) 2004, 2005 Brian Sutherland <jinty@web.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""Some Common functions used in the tests"""

from StringIO import StringIO
import difflib
from xml.dom import ext


def stringify(element):
    """Convert a DOM element to a nice looking string."""
    outstr = StringIO()
    ext.PrettyPrint(element, outstr)
    return outstr.getvalue()

def verifyStrings(str1, str2):
    #return xmlDiff(str1, str2)
    return simpleDiff(str1, str2)

def simpleDiff(str1, str2):
    """Compares two strings of XML to see if they are equal.

    Prints a diff if they are not.
    """
    # Probably could be a _LOT_ more intelligent
    same = True
    lines1 = []
    lines2 = []
    for lines, str in [(lines1, str1), (lines2, str2)]:
        for i in str.splitlines():
            if not i.strip().isspace():
                lines.append(i.strip())
    for line in difflib.unified_diff(lines1, lines2, lineterm=""):
        print line
        same = False
    return same

#from logilab.xmldiff import input, format, fmes
def xmlDiff(str1, str2):
    """Compares two strings of XML to see if they are equal.

    Prints a diff if they are not and returns False, otherwise true.

    EXPERIMENTAL METHOD TO REPLACE verifyStrings - just the output formatting
    is extreemly unreadable....
    """
    tree1 = input.tree_from_stream(StringIO(str1))
    tree2 = input.tree_from_stream(StringIO(str2))
    formatter = format.InternalPrinter()
    strategy = fmes.FmesCorrector(formatter)
    strategy.process_trees(tree1, tree2)
    if len(formatter.edit_s) == 0:
        return True
    return False
